clc
clear all
close all
m2_lin=load('Averaged_fields_1a20_pump1_probe2_250msdelay_linear_sample_01_wLG=7.mat');
m2_8=load('Averaged_fields_1a20_pump1_probe2_250msdelay_252mW_8mW_sample_01_wLG=7.mat');
m2_10=load('Averaged_fields_1a20_pump1_probe2_250msdelay_251mW_10mW_sample_01_wLG=7.mat');
m2_12=load('Averaged_fields_1a20_pump1_probe2_250msdelay_251mW_12mW_sample_01_wLG=7.mat');

m3_lin=load('Averaged_fields_1a20_pump1_probe3_250msdelay_linear_sample_01_wLG=7.mat');
m3_8=load('Averaged_fields_1a20_pump1_probe3_250msdelay_240mW_8mW_sample_01_wLG=7.mat');
m3_10=load('Averaged_fields_1a20_pump1_probe3_250msdelay_240mW_10mW_sample_01_wLG=7.mat');
m3_12=load('Averaged_fields_1a20_pump1_probe3_250msdelay_240mW_12mW_sample_01_wLG=7.mat');

mm1_lin=load('Averaged_fields_1a20_pump1_probem1_250msdelay_linear_sample_01_wLG=7.mat');
mm1_8=load('Averaged_fields_1a20_pump1_probem1_250msdelay_252mW_8mW_sample_01_wLG=7.mat');
mm1_10=load('Averaged_fields_1a20_pump1_probem1_250msdelay_252mW_10mW_sample_01_wLG=7.mat');
mm1_12=load('Averaged_fields_1a20_pump1_probem1_250msdelay_252mW_12mW_sample_01_wLG=7.mat');

mm2_lin=load('Averaged_fields_1a20_pump1_probem2_250msdelay_linear_sample_01_wLG=7.mat');
mm2_8=load('Averaged_fields_1a20_pump1_probem2_250msdelay_252mW_8mW_sample_01_wLG=7.mat');
mm2_10=load('Averaged_fields_1a20_pump1_probem2_250msdelay_252mW_10mW_sample_01_wLG=7.mat');
mm2_12=load('Averaged_fields_1a20_pump1_probem2_250msdelay_252mW_12mW_sample_01_wLG=7.mat');

[Nx,Nt] = size(m2_8.av_recEs); 
dr=3.375; %um
r=linspace(1,402,402).*dr; %um
x = linspace(-400,400,801).*dr;
y = linspace(-400,400,801).*dr;
[X,Y] = meshgrid(x,y);
[theta,r] = cart2pol(X,Y);

%%
figure('Position',[50 50 800 400])
sgtitle('Pump OAM = 1, P_{pu}=252mW, P_{signal}=12 mW')
subplot(2,4,5),imagesc(x,y,m3_12.av_recEi)
xlim([-500 500])
ylim([-500 500])
title('idler OAM -1')
axis square
subplot(2,4,1),imagesc(x,y,m3_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM 3')
axis square
subplot(2,4,6),imagesc(x,y,m2_12.av_recEi)
xlim([-500 500])
ylim([-500 500])
title('idler OAM 0')
axis square
subplot(2,4,2),imagesc(x,y,m2_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM 2')
axis square
subplot(2,4,7),imagesc(x,y,mm1_12.av_recEi)
xlim([-500 500])
ylim([-500 500])
title('idler OAM 3')
axis square
subplot(2,4,3),imagesc(x,y,mm1_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM -1')
axis square
subplot(2,4,8),imagesc(x,y,mm2_12.av_recEi)
xlim([-500 500])
ylim([-500 500])
title('idler OAM 4')
axis square
subplot(2,4,4),imagesc(x,y,mm2_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM -2')
axis square

%% ergoregion
r_ergo = 118; % um
%% calculate reflectivity (small window)
mask = (Y).^2 ...
    + (X ).^2 <= r_ergo.^2;

%% m=3
Rm3_8 = dr.^2 .*sum(sum((1-mask).*(abs(m3_8.av_recEs).^2-abs(m3_8.av_recEi).^2)));
Nm3_8 = dr.^2 .*sum(sum((abs(m3_8.av_recEs).^2-abs(m3_8.av_recEi).^2)));
REFLm3_8= Rm3_8/Nm3_8

Rm3_10 = dr.^2 .*sum(sum((1-mask).*(abs(m3_10.av_recEs).^2-abs(m3_10.av_recEi).^2)));
Nm3_10 = dr.^2 .*sum(sum((abs(m3_10.av_recEs).^2-abs(m3_10.av_recEi).^2)));
REFLm3_10= Rm3_10/Nm3_10

Rm3_12 = dr.^2 .*sum(sum((1-mask).*(abs(m3_12.av_recEs).^2-abs(m3_12.av_recEi).^2)));
Nm3_12 = dr.^2 .*sum(sum((abs(m3_12.av_recEs).^2-abs(m3_12.av_recEi).^2)));
REFLm3_12= Rm3_12/Nm3_12
%% m=2
Rm2_8 = dr.^2 .*sum(sum((1-mask).*(abs(m2_8.av_recEs).^2-abs(m2_8.av_recEi).^2)));
Nm2_8 = dr.^2 .*sum(sum((abs(m2_8.av_recEs).^2-abs(m2_8.av_recEi).^2)));
REFLm2_8= Rm2_8/Nm2_8

Rm2_10 = dr.^2 .*sum(sum((1-mask).*(abs(m2_10.av_recEs).^2-abs(m2_10.av_recEi).^2)));
Nm2_10 = dr.^2 .*sum(sum((abs(m2_10.av_recEs).^2-abs(m2_10.av_recEi).^2)));
REFLm2_10= Rm2_10/Nm2_10

Rm2_12 = dr.^2 .*sum(sum((1-mask).*(abs(m2_12.av_recEs).^2-abs(m2_12.av_recEi).^2)));
Nm2_12 = dr.^2 .*sum(sum((abs(m2_12.av_recEs).^2-abs(m2_12.av_recEi).^2)));
REFLm2_12= Rm2_12/Nm2_12
%% m=-1
Rmm1_8 = dr.^2 .*sum(sum((1-mask).*(abs(mm1_8.av_recEs).^2-abs(mm1_8.av_recEi).^2)));
Nmm1_8 = dr.^2 .*sum(sum((abs(mm1_8.av_recEs).^2-abs(mm1_8.av_recEi).^2)));
REFLmm1_8= Rmm1_8/Nmm1_8

Rmm1_10 = dr.^2 .*sum(sum((1-mask).*(abs(mm1_10.av_recEs).^2-abs(mm1_10.av_recEi).^2)));
Nmm1_10 = dr.^2 .*sum(sum((abs(mm1_10.av_recEs).^2-abs(mm1_10.av_recEi).^2)));
REFLmm1_10= Rmm1_10/Nmm1_10

Rmm1_12 = dr.^2 .*sum(sum((1-mask).*(abs(mm1_12.av_recEs).^2-abs(mm1_12.av_recEi).^2)));
Nmm1_12 = dr.^2 .*sum(sum((abs(mm1_12.av_recEs).^2-abs(mm1_12.av_recEi).^2)));
REFLmm1_12= Rmm1_12/Nmm1_12
%% m=-2
Rmm2_8 = dr.^2 .*sum(sum((1-mask).*(abs(mm2_8.av_recEs).^2-abs(mm2_8.av_recEi).^2)));
Nmm2_8 = dr.^2 .*sum(sum((abs(mm2_8.av_recEs).^2-abs(mm2_8.av_recEi).^2)));
REFLmm2_8= Rmm2_8/Nmm2_8

Rmm2_10 = dr.^2 .*sum(sum((1-mask).*(abs(mm2_10.av_recEs).^2-abs(mm2_10.av_recEi).^2)));
Nmm2_10 = dr.^2 .*sum(sum((abs(mm2_10.av_recEs).^2-abs(mm2_10.av_recEi).^2)));
REFLmm2_10= Rmm2_10/Nmm2_10

Rmm2_12 = dr.^2 .*sum(sum((1-mask).*(abs(mm2_12.av_recEs).^2-abs(mm2_12.av_recEi).^2)));
Nmm2_12 = dr.^2 .*sum(sum((abs(mm2_12.av_recEs).^2-abs(mm2_12.av_recEi).^2)));
REFLmm2_12= Rmm2_12/Nmm2_12

OAM1 = [3,2,-1,-2]-1;
REFL_8= [REFLm3_8,REFLm2_8,REFLmm1_8,REFLmm2_8];
REFL_10= [REFLm3_10,REFLm2_10,REFLmm1_10,REFLmm2_10];
REFL_12= [REFLm3_12,REFLm2_12,REFLmm1_12,REFLmm2_12];
one = ones(4);
%%
figure
plot(OAM1,REFL_8,'d',OAM1,REFL_10,'p',OAM1,REFL_12,'o', OAM1, one, 'Linewidth',2)
xlabel('n-L')
ylabel('Reflectivity R(z)/N(z)')
legend('P_s = 8mW','P_s = 10mW','P_s = 12mW','Location','northwest')
title('OAM pump L=1, OAM signal n=(3,2,-1,-2)')
set(gca, 'FontSize',16)
r=linspace(1,402,402).*dr; %um

%% same OAM different power normalized to unity
figure
subplot(221)
plot(r,m3_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m3_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,m3_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m3_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,m3_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m3_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,m3_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m3_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r (\mum)')
ylabel('J_0')
title('pump 1, signal 3, idler -1')
legend('linear','8mW','10mW','12mW')

subplot(222)
plot(r,m2_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m2_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,m2_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m2_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,m2_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m2_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,m2_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m2_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r (\mum)')
ylabel('J_0')
title('pump 1, signal 2, idler 0')
legend('linear','8mW','10mW','12mW')

subplot(223)
plot(r,mm1_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm1_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,mm1_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm1_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,mm1_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm1_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,mm1_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm1_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r(\mum)')
ylabel('J_0')
title('pump 1, signal -1, idler 3')
legend('linear','8mW','10mW','12mW')

subplot(224)
plot(r,mm2_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm2_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,mm2_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm2_8.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,mm2_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm2_10.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,mm2_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm2_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r (\mum)')
ylabel('J_0')
title('pump 1, signal -2, idler 4')
legend('linear','8mW','10mW','12mW')
saveas(gcf,'currents_comparison_pump1_probe3_2_m1_m2.png')
saveas(gcf,'currents_comparison_pump1_probe3_2_m1_m2.fig')


